SystemOrganization addCategory: #'Monticello2-Elements'!
SystemOrganization addCategory: #'Monticello2-Fakes'!
SystemOrganization addCategory: #'Monticello2-Repositories'!
SystemOrganization addCategory: #'Monticello2-Slices'!
SystemOrganization addCategory: #'Monticello2-Squeak'!
SystemOrganization addCategory: #'Monticello2-Tests'!
SystemOrganization addCategory: #'Monticello2-Versions'!

!MethodReference methodsFor: '*monticello2' stamp: 'cwp 3/3/2005 02:15'!
asElement
	^ MDMethodElement 
		className: classSymbol 
		selector: methodSymbol
		classIsMeta: classIsMeta! !

!Symbol class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:03'!
materializeWith: aMarshal
	^ aMarshal readSymbol! !

!SmallInteger class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:21'!
materializeWith: aMarshal
	^ aMarshal readSmallInteger! !

!Object class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:59'!
materializeWith: aMarshal
	^ aMarshal readObject: self basicNew! !

Object subclass: #MDMemoryRepository
	instanceVariableNames: 'versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 3/10/2005 20:20'!
put: anElementVersion
	versions at: anElementVersion hashstamp put: anElementVersion! !

!MDMemoryRepository methodsFor: 'public' stamp: 'avi 3/12/2005 02:46'!
hashstampsForClass: aClass do: aBlock
	versions keysAndValuesDo:
		[:hashstamp :version |
		(version isKindOf: aClass)
			ifTrue: [aBlock value: hashstamp]]! !

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 3/10/2005 20:20'!
get: aHashstamp
	^ versions at: aHashstamp! !

!MDMemoryRepository methodsFor: 'initialize-release' stamp: 'cwp 2/21/2005 20:20'!
initialize
	versions _ Dictionary new.! !

Object subclass: #MDSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

!MDSlice methodsFor: 'accessing' stamp: 'cwp 2/27/2005 19:08'!
elements
	| result |
	result _ Set new.
	self do: [:ea | result add: ea].
	^ result! !

!MDSlice methodsFor: 'private' stamp: 'cwp 2/27/2005 21:31'!
expandVersions: versions
	| existingElements result |
	existingElements _ versions collect: [:ea | ea element]. 
	result _ versions copy.
	self do: [:el | (existingElements includes: el) 
					ifFalse: [result add: (MDNullVersion forElement: el)]].
	^ result! !

!MDSlice methodsFor: 'working copy' stamp: 'cwp 3/10/2005 22:56'!
saveFrom: aWorkingCopy to: aRepository
	| snapshot |
	snapshot _ MDSnapshot buildIn: 
		[:properties :versions |
		self do: [:ea | | version |
				version _ aWorkingCopy versionForElement: ea.
				aRepository put: version.
				versions add: version]].
	aRepository put: snapshot.
	^ snapshot! !

MDSlice subclass: #MDExplicitSlice
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

!MDExplicitSlice methodsFor: 'enumerating' stamp: 'cwp 2/27/2005 18:57'!
do: aBlock	
	^ elements do: aBlock! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'cwp 2/27/2005 18:54'!
addElement: anElement
	elements add: anElement! !

!MDExplicitSlice methodsFor: 'initialize-release' stamp: 'cwp 2/27/2005 18:53'!
initialize
	elements _ Set new! !

!MDSlice methodsFor: 'working copy' stamp: 'cwp 3/10/2005 22:19'!
load: aSnapshot from: aRepository to: aWorkingCopy
	(self expandVersions: (aSnapshot getVersionsFrom: aRepository))
		do: [:ea | aWorkingCopy loadVersion: ea]! !

!MDSlice methodsFor: 'working copy' stamp: 'cwp 3/10/2005 21:50'!
include: aSnapshot from: aRepository in: aWorkingCopy
	| versions |
	versions _ aSnapshot getVersionsFrom: aRepository.
	MDMergeRequest 
		includeVersions: (self expandVersions: versions)
		in: aWorkingCopy! !

MDSlice subclass: #MDPackageSlice
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

!MDPackageSlice methodsFor: 'private' stamp: 'cwp 3/4/2005 15:26'!
class: aClass do: aBlock
	aBlock value: (MDClassElement className: aClass name).
	aClass hasComment ifTrue:
		[aBlock value: (MDClassCommentElement className: aClass name)].
	self 
		names: aClass instVarNames 
		collect: [:name | MDInstVarElement className: aClass name name: name]
		into: aBlock.
	self 
		names: aClass classVarNames
		collect: [:name | MDClassVarElement className: aClass name name: name]
		into: aBlock.
	self 
		names: aClass class instVarNames
		collect: [:name | MDClassInstVarElement className: aClass name name: name]
		into: aBlock.
	self
		names: aClass sharedPools
		collect: [:pool | MDPoolImportElement className: aClass name poolName: pool name]
		into: aBlock! !

!MDPackageSlice methodsFor: 'private' stamp: 'cwp 3/3/2005 01:48'!
names: aCollection collect: mapBlock into: doBlock
	| elements |
	elements := aCollection collect: mapBlock.
	elements do: doBlock. 
		! !

!MDPackageSlice methodsFor: 'enumerating' stamp: 'cwp 3/3/2005 02:21'!
do: aBlock
	package classes do: [:class | self class: class do: aBlock].
	package methods do: [:ea | aBlock value: ea asElement].! !

!MDPackageSlice methodsFor: 'initialize-release' stamp: 'cwp 3/3/2005 00:49'!
setPackage: aPackage
	package _ aPackage! !

!MDPackageSlice class methodsFor: 'instance creation' stamp: 'cwp 3/3/2005 00:49'!
forPackage: aPackage
	^ self basicNew setPackage: aPackage! !

!MDSlice methodsFor: 'enumerating' stamp: 'cwp 2/27/2005 22:54'!
do: aBlock
	self subclassResponsibility! !

Object subclass: #MDSqueakElementAdaptor
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:44'!
elementClassIfAbsent: aBlock
	^ Smalltalk at: element theClassName ifAbsent: aBlock! !

!MDSqueakElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 2/5/2005 16:55'!
setElement: anElement
	element _ anElement! !

!MDSqueakElementAdaptor methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:39'!
propertyNames
	^ #()! !

MDSqueakElementAdaptor subclass: #MDSqueakClassCommentAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:34'!
stamp
	^ self elementClass organization commentStamp! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 3/11/2005 21:02'!
text
	^ self elementClass comment asString! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:55'!
load: properties
	self elementClass
		classComment: properties text
		stamp: (self stampFromProperties: properties)! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:59'!
remove
	self elementClass organization classComment: nil stamp: nil.
! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:29'!
propertyNames
	^ #(text author timeStamp)! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:22'!
isPresent
	^ self elementClass hasComment! !

MDSqueakElementAdaptor subclass: #MDSqueakClassVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:49'!
isPresent
	^ self elementClass classVarNames includes: element name! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:59'!
remove
	self isPresent ifTrue: [self elementClass removeClassVarName: element name]! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 14:00'!
load: properties
	self isPresent ifFalse: [self elementClass addClassVarName: element name]! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:47'!
isLoadable: properties
	self elementClassIfAbsent: [^ false].
	^ true! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 3/11/2005 22:50'!
update: properties
	self propertyNames do: 
		[:name | (self perform: name) ifNotNilDo: 
			[:value | properties at: name put: value]]! !

MDSqueakElementAdaptor subclass: #MDSqueakPoolImportAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:41'!
load: properties
	self elementClass addSharedPool: self importedPool! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:44'!
remove
	"Work around a bug in Class>>removeSharedPool:"
	
	self elementClass sharedPools remove: self importedPool ifAbsent: []! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:34'!
isPresent
	^ self elementClass sharedPools anySatisfy: [:ea | ea name = element poolName]! !

!MDSqueakPoolImportAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 23:41'!
importedPool
	^ Smalltalk at: element poolName! !

MDSqueakElementAdaptor subclass: #MDSqueakMethodAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 3/11/2005 20:44'!
source
	^ (self elementClass sourceCodeAt: (element selector)) asString.! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:06'!
category
	^ self elementClass organization categoryOfElement: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 12:45'!
load: properties
	self elementClass
		compile: (properties at: #source ifAbsent: [self source])
		classified: (properties at: #category ifAbsent: [self category])
		withStamp: (self stampFromProperties: properties)
		notifying: nil
		logSource: true! !

!MDSqueakMethodAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:44'!
compiledMethod 
	^ self elementClass compiledMethodAt: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:19'!
remove
	self elementClass removeSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:30'!
stamp
	^self compiledMethod timeStamp! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:12'!
propertyNames
	^ #(author timeStamp category source)! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:24'!
elementClassIfAbsent: aBlock
	| nonMetaClass |
	nonMetaClass := super elementClassIfAbsent: aBlock.
	^ element classIsMeta
		ifTrue: [nonMetaClass class]
		ifFalse: [nonMetaClass]! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:22'!
isPresent
	^ self elementClass includesSelector: element selector! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 21:40'!
isUpToDate: properties 
	self propertyNames
		do: [:property | (self is: property upToDateIn: properties) ifFalse: [^ false]].
	^ true
! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 3/11/2005 23:11'!
author
	| author |
	author _ self stamp copyUpTo: $ .
	^ author isEmpty ifFalse: [author] ifTrue: [nil]! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
remove
	self subclassResponsibility! !

MDSqueakElementAdaptor subclass: #MDSqueakClassAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:31'!
sharedPoolsString
	^ self send: #sharedPoolsString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/15/2005 15:05'!
superclassFrom: properties ifAbsent: absentBlock 
	| global |
	global _ Smalltalk 
				at: properties superclassName 
				ifAbsent: [^ absentBlock value].
	^ (global isKindOf: Class)
		ifTrue: [global]
		ifFalse: absentBlock! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:39'!
elementClass
	^ Smalltalk at: element theClassName ifAbsent: [nil]! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/5/2005 23:02'!
propertyNames
	^ #(category format superclassName)! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:31'!
isLoadable: properties 
	self superclassFrom: properties ifAbsent: [^ false].
	^ true! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 22:25'!
load: properties
	| superClass |
	superClass _ Smalltalk at: properties superclassName.
	ClassBuilder new
		name: element theClassName 
		inEnvironment: superClass environment 
		subclassOf: superClass
		type: properties format 
		instanceVariableNames: self instanceVariablesString 
		classVariableNames: self classVariablesString 
		poolDictionaries: self sharedPoolsString
		category: properties category
! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
format
	^ self elementClass typeOfClass! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:39'!
send: aSelector toClassIfNil: aBlock
	| class |
	class := self elementClass.
	^ class 
		ifNotNil: [class perform: aSelector]
		ifNil: aBlock! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
classVariablesString
	^ self send: #classVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
instanceVariablesString
	^ self send: #instanceVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:40'!
superclassName
	^ self elementClass superclass name! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
category
	^ self elementClass category! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 21:23'!
isPresent
	^ (Smalltalk at: element theClassName ifAbsent: [^ false])
		isKindOf: Class! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:32'!
theClass
	^ Smalltalk at: element theClassName ifAbsent: [nil]! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 12:39'!
remove
	self elementClass ifNotNilDo: [:class | class removeFromSystem]! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:44'!
elementClass
	^ self elementClassIfAbsent: [nil]! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 2/12/2005 14:52'!
stampFromProperties: properties
	| author timestamp |
	author _ properties at: #author ifAbsent: ['<nobody>'].
	timestamp _ properties at: #timeStamp ifAbsent: [^ '<no timestamp>'].
	^ String streamContents: 
		[:stream |
		stream nextPutAll: author.
		stream nextPut: $ .
	 	timestamp asDate printOn: stream format: #(2 1 3 $/ 1 1).
		stream nextPut: $ .
		timestamp asTime print24: true showSeconds: false on: stream]
		! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
load: properties
	self subclassResponsibility! !

!MDSqueakElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 2/5/2005 20:56'!
forElement: anElement
	^ self new setElement: anElement! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 3/4/2005 15:38'!
timeStamp
	| stamp |
	stamp := self stamp.
	^ (stamp = '<historical>' or: [stamp = ''])
		ifFalse: [TimeStamp fromMethodTimeStamp: stamp]
		ifTrue: [nil]
! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 21:40'!
is: name upToDateIn: properties
	^ (properties at: name ifAbsent: [^ true]) = (self perform: name)
	! !

MDSqueakElementAdaptor subclass: #MDSqueakInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 12:50'!
isPresent
	^ self elementClass instVarNames includes: element name! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:56'!
remove
	self isPresent ifTrue: [self elementClass removeInstVarName: element name]! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:56'!
load: properties
	self isPresent ifFalse: [self elementClass addInstVarName: element name]! !

MDSqueakInstVarAdaptor subclass: #MDSqueakClassInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassInstVarAdaptor methodsFor: 'accessing' stamp: 'cwp 3/4/2005 15:04'!
elementClassIfAbsent: aBlock
	^ (super elementClassIfAbsent: aBlock) class! !

Object subclass: #MDImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageProxy methodsFor: 'public' stamp: 'cwp 3/4/2005 15:56'!
loadSnapshot: anElementSnapshot
	anElementSnapshot loadInto: self! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/3/2005 23:56'!
hasElement: anElement
	^ (anElement adaptedFor: self) isPresent! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/13/2005 19:39'!
isLoadable: anElementSnapshot
	^ anElementSnapshot isLoadableInto: self! !

MDImageProxy subclass: #MDSqueakImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForInstVarElement: anElement
	^ MDSqueakInstVarAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForClassElement: anElement
	^ MDSqueakClassAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/7/2005 00:00'!
adaptorForPoolImportElement: anElement
	^ MDSqueakPoolImportAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/4/2005 14:50'!
adaptorForClassInstVarElement: anElement
	^ MDSqueakClassInstVarAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForMethodElement: anElement
	^ MDSqueakMethodAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/12/2005 14:06'!
adaptorForClassCommentElement: anElement
	^ MDSqueakClassCommentAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForClassVarElement: anElement
	^ MDSqueakClassVarAdaptor forElement: anElement! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/29/2004 13:26'!
isUpToDate: anElementSnapshot
	^ anElementSnapshot isUpToDateFor: self! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/27/2005 22:00'!
updateSnapshot: anElementSnapshot
	^ anElementSnapshot updateFrom: self! !

MDImageProxy subclass: #MDFakeImageProxy
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/4/2005 00:23'!
removeKey: anElement
	dict removeKey: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:29'!
adaptorForClassVarElement: anClassVarElement
	^ self adaptorForElement: anClassVarElement! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/4/2005 00:28'!
includesKey: anElement 
	^ dict includesKey: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/12/2005 14:04'!
adaptorForClassCommentElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/5/2005 16:08'!
at: anElement
	^ dict at: anElement ifAbsentPut: [Dictionary new]
! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:29'!
adaptorForInstVarElement: anInstVarElement
	^ self adaptorForElement: anInstVarElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/5/2005 19:05'!
adaptorForElement: anElement 
	^ MDFakeElementAdaptor
		forElement: anElement
		inImage: dict! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/7/2005 00:01'!
adaptorForPoolImportElement: aPoolImportElement 
	^ self adaptorForElement: aPoolImportElement! !

!MDFakeImageProxy methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:23'!
initialize
	dict _ Dictionary new! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:25'!
at: anElement put: aPropertyDictionary
	dict at: anElement put: aPropertyDictionary! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/5/2005 19:05'!
adaptorForMethodElement: aMethodElement 
	^ self adaptorForElement: aMethodElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 3/4/2005 14:46'!
adaptorForClassInstVarElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:18'!
adaptorForClassElement: aClassElement 
	^ self adaptorForElement: aClassElement! !

Object subclass: #MDWorkingCopy
	instanceVariableNames: 'proxy versions slush'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

MDWorkingCopy class
	instanceVariableNames: 'default'!

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 3/2/2005 23:38'!
newVersionForElement: anImageElement
	| oldVersion newSnapshot |
	oldVersion _ versions at: anImageElement.
	newSnapshot _ oldVersion snapshot copy.
	^ versions 
		at: anImageElement
		put: (MDElementVersion
				snapshot: (proxy updateSnapshot: newSnapshot)
				ancestry: oldVersion fullAncestry)! !

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'cwp 3/4/2005 15:32'!
defaultImageProxy
	^ MDSqueakImageProxy new! !

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:56'!
forImageProxy: anImageProxy
	^ self basicNew initializeWithImageProxy: anImageProxy! !

!MDWorkingCopy methodsFor: 'public' stamp: 'cwp 2/13/2005 15:29'!
versionForElement: anImageElement
	| old |
	old _ versions 
			at: anImageElement 
			ifAbsent: [^ self createVersionForElement: anImageElement].
	^ (proxy isUpToDate: old snapshot)
		ifTrue: [old]
		ifFalse: [self newVersionForElement: anImageElement]! !

!MDWorkingCopy methodsFor: 'public' stamp: 'cwp 3/2/2005 23:58'!
includeVersion: anElementVersion onConflict: twoArgBlock 
	| current successor |
	current := self versionForElement: anElementVersion element.
	successor := current 
					successor: anElementVersion 
					onConflict: [twoArgBlock 
									value: current
									value: anElementVersion].
	successor == current ifTrue: [^ false].
	self loadVersion: successor.	
	^true! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 3/10/2005 22:17'!
loadSlush: loading
	| unloadable |
	unloadable _ Set new.
	loading do: [:ea | (proxy isLoadable: ea snapshot)
						ifTrue: [proxy loadSnapshot: ea snapshot]
						ifFalse: [unloadable add: ea]].
	^ unloadable! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 2/27/2005 22:09'!
createVersionForElement: anElement 
	| snapshot version |
	(proxy hasElement: anElement) ifFalse: [^ MDNullVersion forElement: anElement].
	snapshot _ (MDElementDefinition forElement: anElement) updateFrom: proxy.
	version _ MDElementVersion snapshot: snapshot.
	versions at: anElement put: version.
	^ version! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 3/10/2005 22:14'!
loadSlush
	| loading |	
	[loading _ slush.
	slush _ self loadSlush: loading.
	loading size > slush size] whileTrue.
	! !

!MDWorkingCopy methodsFor: 'public' stamp: 'cwp 3/10/2005 22:12'!
loadVersion: anElementVersion

	versions at: anElementVersion element put: anElementVersion.
	slush add: anElementVersion.
	self loadSlush! !

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'cwp 3/11/2005 20:48'!
resetDefault
	default _ nil! !

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'cwp 3/4/2005 15:32'!
default
	^ default ifNil: [default _ self forImageProxy: self defaultImageProxy]! !

!MDWorkingCopy methodsFor: 'initialize-release' stamp: 'cwp 3/10/2005 22:12'!
initializeWithImageProxy: anImageProxy
	proxy _ anImageProxy.
	versions _ Dictionary new.
	slush _ Set new.! !

Object subclass: #MDMarshal
	instanceVariableNames: 'stream'
	classVariableNames: 'ClassMap InverseClassMap'
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDMarshal commentStamp: 'cwp 3/9/2005 22:40' prior: 0!
I am used to serialize versioning objects - Elements, ElementDefinitions, ElementRemovals, ElementVersions and Snapshots - both for persistence and hashing. My serialization scheme is remeniscent of that used by DataStream, but it has the following differences:

Rather than type codes, I use class ids. This is because I don't have to be able to handle any object, but only those classes mentioned above. I encode class ids as a single byte, but only 22 classes are used so far, so there is room to add more if need be. 

Also, I'm more verbose than a ReferenceStream, but this is unavoidable, since I must always produce a canonical serialization of any object in the tree, not just one that can reproduce the original root object. 

Finally, I'm less flexible than DataStream, since I provide no hooks to allow objects to customize how they are serialized. I use double dispatch to find appropriate encoding and decoding methods for objects.
!

!MDMarshal class methodsFor: 'public' stamp: 'cwp 3/9/2005 00:01'!
serialize: anObject on: aWriteStream
	|  instance |
	aWriteStream binary.
	instance _ self on: aWriteStream.
	instance serialize: anObject.
	^ aWriteStream contents
! !

!MDMarshal methodsFor: 'public' stamp: 'cwp 3/9/2005 20:51'!
materialize
	| class |
	class _ MDMarshal classFromId: stream next.
	^ class materializeWith: self! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 21:49'!
writeBoolean: aBoolean! !

!MDMarshal class methodsFor: 'initialize-release' stamp: 'avi 3/12/2005 04:06'!
initialize
	ClassMap _ #(
		True
		False
		SmallInteger
		Symbol
		String
		MultiString
		Set
		TimeStamp
		MDClassCommentElement
		MDClassElement
		MDClassInstVarElement
		MDClassVarElement
		MDElementDefinition
		MDElementRemoval
		MDElementVersion
		MDFakeElement
		MDHashstamp
		MDInstVarElement
		MDMethodElement
		MDPoolImportElement
		MDPropertyDictionary
		MDSnapshot
	) collect: [:ea | Smalltalk at: ea].

	InverseClassMap _ Dictionary new.
	ClassMap withIndexDo:
		[:ea :i |
		InverseClassMap at: ea put: i]! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:52'!
readBooleanOfClass: aClass
	^ aClass initializedInstance! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 23:51'!
writeSmallInteger: aSmallInteger
	stream 
		nextPut: (aSmallInteger bitShift: -24);
		nextPut: ((aSmallInteger bitShift: -16) bitAnd: 16rFF);
		nextPut: ((aSmallInteger bitShift: -8) bitAnd: 16rFF);
		nextPut: (aSmallInteger bitAnd: 16rFF)! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:18'!
writeObject: anObject
	1 to: anObject class instSize do: [:i | self serialize: (anObject instVarAt: i)]! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:04'!
readSmallInteger
	| integer |
	integer _ stream next bitShift: 24.
	integer _ integer bitOr: (stream next bitShift: 16).
	integer _ integer bitOr: (stream next bitShift: 8).
	^ integer bitOr: stream next! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 22:14'!
writeHashstamp: aHashstamp
	1 to: 20 do: [:i | stream nextPut: (aHashstamp hash digitAt: i)].
	self writeTimestamp: aHashstamp timestamp! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/12/2005 01:10'!
readTimestamp
	| a b c d days seconds |
	a _ stream next.
	b _ stream next.
	c _ stream next.
	d _ stream next.
	days _ (a bitShift: 7) bitOr: (b bitShift: - 1).
	seconds _ (((b bitShift: 16) bitOr: (c bitShift: 8)) bitOr: d) bitAnd: 16r1FFFF.
	^ TimeStamp 
		fromJdn: MDHashstamp epoch julianDayNumber + days
		seconds: seconds! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:12'!
writeString: aString
	aString size > 16rFFFF ifTrue: [aString error: 'String too long to serialize'].
	stream
		nextPut: (aString byteSize bitShift: -8);
		nextPut: (aString byteSize bitAnd: 16rFF).
	1 to: aString byteSize do: [:i | stream nextPut: (aString byteAt: i)]! !

!MDMarshal class methodsFor: 'class ids' stamp: 'cwp 3/11/2005 23:23'!
classIdForObject: anObject 
	^ InverseClassMap
		at: anObject class
		ifAbsent: [self error: 'Unrecognized object class']! !

!MDMarshal methodsFor: 'public' stamp: 'cwp 3/9/2005 20:37'!
serialize: anObject
	stream nextPut: (self classIdOfObject: anObject).
	anObject serializeWith: self! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 20:50'!
readStringOfClass: aClass
	| size bytes |
	size _ (stream next bitShift: 8) bitOr: stream next.
	bytes _ stream next: size.
	^ aClass fromByteArray: bytes! !

!MDMarshal methodsFor: 'initialize-release' stamp: 'cwp 3/7/2005 21:34'!
setStream: aStream
	stream _ aStream! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 3/8/2005 23:59'!
serialize: anObject
	| byteStream |
	byteStream _ (ByteArray new: 100) writeStream.
	self serialize: anObject on: byteStream.
	^ byteStream contents
! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:15'!
readSetOfClass: aClass
	| size set |
	size _ self readSmallInteger.
	set _ aClass new: size.
	size timesRepeat: [set add: self materialize].
	^ set! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 3/9/2005 00:59'!
materializeFrom: aWriteStram
	| instance |
	aWriteStram binary.
	instance _ self on: aWriteStram.
	^ instance materialize! !

!MDMarshal methodsFor: 'private' stamp: 'cwp 3/7/2005 21:53'!
classFromId: anInteger
	^ ClassMap at: anInteger! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 20:57'!
readSymbol
	^ (self readStringOfClass: String) asSymbol! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 3/9/2005 00:00'!
materialize: aByteArray
	^ self materializeFrom: aByteArray readStream! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:00'!
readObject: anObject
	1
		to: anObject class instSize 
		do: [:i | anObject instVarAt: i put: (self materialize)].
	^ anObject! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:59'!
readDictionaryOfClass: aClass
	| size dictionary |
	size _ stream next.
	dictionary _ aClass new: size.
	size timesRepeat:
		[dictionary 
			at: self materialize 
			put: self materialize].
	^ dictionary
! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 22:13'!
readHashstamp: aHashstamp
	| hash timestamp |
	hash _ LargePositiveInteger new: 20.
	1 to: 20 do: [:i | hash digitAt: i put: stream next].
	timestamp _ self readTimestamp.
	
	^ aHashstamp
		instVarAt: 1 put: hash;
		instVarAt: 2 put: timestamp;
		yourself
! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:39'!
writeSet: aSet
	self writeSmallInteger: aSet size.
	aSet do: [:ea | self serialize: ea]! !

!MDMarshal class methodsFor: 'instance creation' stamp: 'cwp 3/7/2005 21:35'!
on: aStream
	^ self new setStream: aStream! !

!MDMarshal methodsFor: 'private' stamp: 'avi 3/12/2005 04:08'!
classIdOfObject: anObject
	^ self class classIdForObject: anObject! !

!MDMarshal class methodsFor: 'class ids' stamp: 'cwp 3/7/2005 16:10'!
classFromId: anInteger
	^ ClassMap at: anInteger! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/12/2005 01:03'!
writeTimestamp: aTimestamp
	| days seconds |
	days _ aTimestamp julianDayNumber - MDHashstamp epoch julianDayNumber.
	seconds _ aTimestamp secondsSinceMidnight.
	stream
		nextPut: (days bitShift: -7);
		nextPut: (((days bitShift: 1) bitOr: ((seconds bitShift: -16) bitAnd: 1)) bitAnd: 16rFF);
		nextPut: ((seconds bitShift: -8) bitAnd: 16rFF);
		nextPut: (seconds bitAnd: 16rFF)! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:44'!
writeDictionary: aDictionary
	stream nextPut: aDictionary size.
	aDictionary keysAndValuesDo:
		[:key :value |
		self serialize: key.
		self serialize: value]! !

Object subclass: #MDHashedObject
	instanceVariableNames: 'hashstamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

MDHashedObject subclass: #MDSnapshot
	instanceVariableNames: 'properties contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDSnapshot methodsFor: 'repository' stamp: 'cwp 3/10/2005 22:57'!
getVersionsFrom: aRepository
	^ contents collect: [:ea | aRepository get: ea]! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 3/10/2005 22:49'!
contents
	^ contents! !

!MDSnapshot class methodsFor: 'instance creation' stamp: 'cwp 3/10/2005 22:57'!
buildIn: aBlock
	^ self basicNew initializeIn: aBlock! !

!MDSnapshot methodsFor: 'initialize-release' stamp: 'cwp 3/10/2005 22:59'!
initializeIn: aBlock
	| versions |
	properties _ MDPropertyDictionary new.
	versions _ Set new.
	aBlock value: properties value: versions.
	contents _ versions collect: [:ea | ea hashstamp].
	hashstamp _ MDHashstamp hashIn: 
		[:marshal |
		marshal 
			serialize: properties; 
			serialize: contents].
	! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 3/10/2005 22:51'!
properties
	^ properties! !

!MDSnapshot class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:52'!
extension
	^ 'snap'! !

!MDHashedObject methodsFor: 'comparing' stamp: 'avi 3/12/2005 02:49'!
hash
	^ hashstamp hash! !

!MDHashedObject methodsFor: 'accessing' stamp: 'avi 3/12/2005 02:49'!
hashstamp
	^ hashstamp! !

MDHashedObject subclass: #MDVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
succeeds: anElementVersion 
	^anElementVersion precedes: self! !

!MDVersion class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:53'!
extension
	^ 'vers'! !

MDVersion subclass: #MDNullVersion
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
ancestry
	^ Set new! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 21:36'!
element
	^ element! !

!MDNullVersion methodsFor: 'initialize-release' stamp: 'cwp 3/10/2005 01:11'!
setElement: anElement
	element _ anElement.
	hashstamp _ MDHashstamp 
					hashIn: [:marshal | marshal serialize: element]
					timestamp: MDHashstamp epoch! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 21:35'!
snapshot
	^ MDElementRemoval forElement: element! !

!MDNullVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
precedes: anElementVersion 
	^true! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
fullAncestry
	^ Set new! !

!MDNullVersion class methodsFor: 'as yet unclassified' stamp: 'cwp 2/27/2005 21:31'!
forElement: anElement
	^ self new setElement: anElement! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 3/2/2005 23:55'!
successor: other onConflict: aBlock
	(self succeeds: other) ifTrue: [^ self].
	(other succeeds: self) ifTrue: [^ other].
	^ MDElementVersion
		snapshot: aBlock value
		ancestry: (self fullAncestry, other fullAncestry).! !

MDVersion subclass: #MDElementVersion
	instanceVariableNames: 'snapshot ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDElementVersion class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:31'!
snapshot: anElementSnapshot ancestry: aSet
	^ self basicNew initializeWithSnapshot: anElementSnapshot ancestry: aSet! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:17'!
snapshot
	^ snapshot! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:56'!
snapshot: anElementSnapshot
	^ self snapshot: anElementSnapshot ancestry: Set new! !

!MDElementVersion methodsFor: 'initialize-release' stamp: 'cwp 3/9/2005 22:49'!
initializeWithSnapshot: elementSnapshot ancestry: aCollection
	snapshot _ elementSnapshot.
	ancestry _ aCollection.
	hashstamp _ MDHashstamp hashIn: [:marshal | marshal 
													serialize: snapshot;
													serialize: ancestry]! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:39'!
element
	^ snapshot element! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 18:01'!
fullAncestry
	^ ancestry copyWith: hashstamp! !

!MDElementVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
precedes: aVersion 
	^aVersion ancestry includes: hashstamp! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:53'!
ancestry
	^ ancestry! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 3/2/2005 22:22'!
conflictsWith: other
	^ ((self precedes: other) or: [self succeeds: other]) not! !

!MDHashedObject methodsFor: 'comparing' stamp: 'avi 3/12/2005 02:49'!
= other
	^ self species = other species and: [self hashstamp = other hashstamp]! !

!MDHashedObject class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:51'!
extension
	self subclassResponsibility! !

Object subclass: #MDFakeElementAdaptor
	instanceVariableNames: 'image element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 2/13/2005 19:29'!
checkDependencies
	self isLoadable ifFalse: [self error: 'Unmet dependency']! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:39'!
isUpToDate: properties
	properties keysAndValuesDo: 
		[:key :value |
		(self properties at: key ifAbsent: [^ false]) = value ifFalse: [^ false]].
	^ true
	! !

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 2/13/2005 19:31'!
isLoadable
	| required |
	(element name includes: $/) ifFalse: [^ true].
	required := element name copyUpTo: $/.
	^ image keys anySatisfy: [:ea | ea name = required]
! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:33'!
update: properties
	self properties keysAndValuesDo: [:key :value | properties at: key put: value]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/13/2005 18:16'!
load: properties 
	self checkDependencies.
	properties keysAndValuesDo: [:key :value | self properties at: key put: value]! !

!MDFakeElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 2/4/2005 00:34'!
setImage: aFakeImageProxy element: anElement
	image _ aFakeImageProxy.
	element _ anElement! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/13/2005 19:44'!
isLoadable: properties
	^ self isLoadable! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:36'!
isPresent
	^ image includesKey: element! !

!MDFakeElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/13/2005 18:17'!
properties
	^ image at: element ifAbsentPut: [Dictionary new]! !

!MDFakeElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 2/4/2005 00:35'!
forElement: anElement inImage: aDictionary
	^ self new setImage: aDictionary element: anElement! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:40'!
remove
	image removeKey: element ifAbsent: []! !

Object subclass: #MDDirectoryRepository
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDDirectoryRepository methodsFor: 'public' stamp: 'avi 3/12/2005 02:55'!
get: aHashstamp
	^ self
		withFile: (directory oldFileNamed: (self findFilenameForHashstamp: aHashstamp))
		do: [:file | MDMarshal materializeFrom: file]! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'avi 3/12/2005 00:58'!
withFile: aFileStream do: aBlock
	^ [aFileStream binary.
	   aBlock value: aFileStream]
			ensure: [aFileStream close]! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'avi 3/12/2005 03:01'!
findFilenameForHashstamp: aHashstamp
	| stamp |
	stamp _ aHashstamp asString.
	self filenamesDo:
		[:ea |
		(ea copyUpToLast: $.) = stamp ifTrue: [^ ea]].
	self error: 'Couldn''t find file for ', stamp! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'avi 3/12/2005 02:57'!
put: aHashedObject
	^ self
		withFile: (directory forceNewFileNamed: (self fileNameFor: aHashedObject))
		do: [:file | MDMarshal serialize: aHashedObject on: file]! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'avi 3/12/2005 03:01'!
hashstampsForClass: aClass do: aBlock
	self filenamesDo:
		[:ea |
		(ea copyAfterLast: $.) = aClass extension
			ifTrue: [aBlock value: (MDHashstamp fromString: (ea copyUpToLast: $.))]]! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'avi 3/12/2005 02:58'!
fileNameFor: aHashedObject
	^ aHashedObject hashstamp asString, '.', aHashedObject class extension! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'avi 3/12/2005 00:49'!
initialize
	directory _ FileDirectory default directoryNamed: 'slice-versions'.
	directory assureExistence! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'avi 3/12/2005 03:19'!
filenamesDo: aBlock
	directory fileNames do: aBlock! !

Object subclass: #MDElementRemoval
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementRemoval class methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:23'!
forElement: anImageElement
	^ self basicNew initializeWithElement: anImageElement! !

!MDElementRemoval methodsFor: 'testing' stamp: 'avi 12/2/2004 01:56'!
isUpToDateFor: anImageProxy
	^ (anImageProxy hasElement: element) not! !

!MDElementRemoval methodsFor: 'comparing' stamp: 'cwp 3/7/2005 17:20'!
= other
	^ self species = other species and: [self element = other element]! !

!MDElementRemoval methodsFor: 'load and save' stamp: 'cwp 2/13/2005 19:52'!
isLoadableInto: anImageProxy
	"Removals are always loadable."
	
	^ true! !

!MDElementRemoval methodsFor: 'initialize-release' stamp: 'avi 12/2/2004 01:23'!
initializeWithElement: anImageElement
	element _ anImageElement! !

!MDElementRemoval methodsFor: 'comparing' stamp: 'cwp 3/7/2005 17:21'!
hash
	^ element hash! !

!MDElementRemoval methodsFor: 'load and save' stamp: 'avi 12/2/2004 01:51'!
updateFrom: anImageProxy
	^ (MDElementDefinition forElement: element) updateFrom: anImageProxy! !

!MDElementRemoval methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ true! !

!MDElementRemoval methodsFor: 'load and save' stamp: 'avi 12/2/2004 01:27'!
loadInto: anImageProxy
	element removeFrom: anImageProxy! !

!MDElementRemoval methodsFor: 'accessing' stamp: 'avi 12/2/2004 01:54'!
element
	^ element! !

Object subclass: #MDImageElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
is: properties upToDateFor: anImageProxy
	^ (self adaptedFor: anImageProxy) isUpToDate: properties! !

MDImageElement subclass: #MDClassCommentElement
	instanceVariableNames: 'theClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassCommentElement methodsFor: 'adapting' stamp: 'cwp 2/12/2005 14:03'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassCommentElement: self! !

!MDClassCommentElement methodsFor: 'accessing' stamp: 'cwp 3/3/2005 02:05'!
theClassName
	^ theClassName! !

!MDClassCommentElement methodsFor: 'initialize-release' stamp: 'cwp 3/3/2005 02:05'!
setClassName: aSymbol 
	theClassName := aSymbol! !

!MDClassCommentElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol 
	^ self basicNew setClassName: aSymbol! !

!MDClassCommentElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 02:03'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]! !

!MDClassCommentElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 02:05'!
hash
	^ theClassName hash! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
update: properties from: anImageProxy
	^ (self adaptedFor: anImageProxy) update: properties! !

MDImageElement subclass: #MDClassVarElement
	instanceVariableNames: 'theClassName name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassVarElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 13:48'!
setClassName: aSymbol name: aString
	theClassName := aSymbol.
	name := aString! !

!MDClassVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 13:52'!
theClassName
	^ theClassName! !

!MDClassVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:38'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]
		and: [self name = other name]! !

!MDClassVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 13:52'!
name
	^ name! !

!MDClassVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:39'!
hash
	^ theClassName hash bitXor: name hash! !

!MDClassVarElement class methodsFor: 'intance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol name: aString
	^ self basicNew setClassName: aSymbol name: aString! !

!MDClassVarElement methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:31'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassVarElement: self! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
removeFrom: anImageProxy
	^ (self adaptedFor: anImageProxy) remove! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

MDImageElement subclass: #MDInstVarElement
	instanceVariableNames: 'theClassName name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDInstVarElement subclass: #MDClassInstVarElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassInstVarElement methodsFor: 'as yet unclassified' stamp: 'cwp 3/4/2005 14:48'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassInstVarElement: self! !

!MDInstVarElement methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:28'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForInstVarElement: self! !

!MDInstVarElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 12:27'!
setClassName: aSymbol name: aString
	theClassName := aSymbol.
	name := aString! !

!MDInstVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:32'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]
		and: [self name = other name]! !

!MDInstVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:32'!
hash
	^ theClassName hash bitXor: name hash! !

!MDInstVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:49'!
theClassName
	^ theClassName! !

!MDInstVarElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:18'!
className: aSymbol name: aString
	^ self basicNew setClassName: aSymbol name: aString! !

!MDInstVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:52'!
name
	^ name! !

MDImageElement subclass: #MDMethodElement
	instanceVariableNames: 'theClassName selector classIsMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:08'!
= other 
	^ (self species = other species) 
		and: [self theClassName = other theClassName]
		and: [self selector = other selector]! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 21:22'!
theClassName
	^theClassName! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'cwp 2/12/2005 15:15'!
setClassName: aString selector: aSymbol classIsMeta: aBoolean
	theClassName := aString.
	selector := aSymbol.
	classIsMeta := aBoolean! !

!MDMethodElement methodsFor: 'converting' stamp: 'cwp 2/3/2005 22:09'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForMethodElement: self! !

!MDMethodElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aString selector: aSymbol 
	^self className: aString selector: aSymbol classIsMeta: false! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:25'!
classIsMeta
	^ classIsMeta! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:16'!
className: aString selector: aSymbol classIsMeta: aBoolean
	^self basicNew setClassName: aString selector: aSymbol classIsMeta: aBoolean! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 21:22'!
hash
	^(theClassName , '|' , selector) hash! !

MDImageElement subclass: #MDPoolImportElement
	instanceVariableNames: 'theClassName poolName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPoolImportElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:57'!
hash
	^ theClassName hash bitXor: poolName hash! !

!MDPoolImportElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 23:36'!
poolName
	^ poolName! !

!MDPoolImportElement methodsFor: 'converting' stamp: 'cwp 2/7/2005 00:01'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForPoolImportElement: self! !

!MDPoolImportElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:56'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]
		and: [self name = other name]! !

!MDPoolImportElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 23:13'!
setClassName: classNameSymbol poolName: poolNameSymbol
	theClassName := classNameSymbol.
	poolName := poolNameSymbol! !

!MDPoolImportElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:18'!
className: classNameSymbol poolName: poolNameSymbol
	^ self basicNew setClassName: classNameSymbol poolName: poolNameSymbol! !

!MDPoolImportElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 23:36'!
theClassName
	^ theClassName! !

!MDImageElement methodsFor: 'testing' stamp: 'cwp 2/4/2005 23:48'!
isMethodElement
	^ false! !

MDImageElement subclass: #MDClassElement
	instanceVariableNames: 'theClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassElement methodsFor: 'as yet unclassified' stamp: 'cwp 3/3/2005 00:56'!
hash
	^ theClassName hash! !

!MDClassElement methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:20'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassElement: self! !

!MDClassElement methodsFor: 'as yet unclassified' stamp: 'cwp 3/3/2005 00:56'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]! !

!MDClassElement methodsFor: 'initialize-release' stamp: 'cwp 2/5/2005 21:27'!
setClassName: aSymbol 
	theClassName := aSymbol! !

!MDClassElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 21:28'!
theClassName
	^ theClassName! !

!MDClassElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol
	^ self basicNew setClassName: aSymbol! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/13/2005 19:42'!
isLoadable: properties into: anImageProxy
	^ (self adaptedFor: anImageProxy) isLoadable: properties
! !

!MDImageElement methodsFor: 'adapting' stamp: 'cwp 2/3/2005 23:54'!
adaptedFor: anImageProxy
	self subclassResponsibility! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
load: properties into: anImageProxy
	^ (self adaptedFor: anImageProxy) load: properties
! !

MDImageElement subclass: #MDFakeElement
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name: aSymbol
	name _ aSymbol! !

!MDFakeElement class methodsFor: 'instance creation' stamp: 'cwp 2/5/2005 19:02'!
named: aSymbol
	^ self new name: aSymbol! !

!MDFakeElement methodsFor: 'public' stamp: 'cwp 2/5/2005 19:03'!
adaptedFor: anImageProxy 
	^ anImageProxy adaptorForElement: self! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
= other
	self species = other species ifFalse: [^ false].
	^ self name = other name! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
hash
	^ name hash! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name
	^ name! !

!Object methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:10'!
serializeWith: aMarshal
	aMarshal writeObject: self! !

Object subclass: #MDElementDefinition
	instanceVariableNames: 'element properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:54'!
loadInto: anImageProxy
	element load: properties into: anImageProxy! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDElementDefinition methodsFor: 'copying' stamp: 'avi 11/29/2004 14:16'!
copy
	| new |
	new _ self species forElement: element.
	properties keysAndValuesDo:
		[:k :v|
		new properties at: k put: v].
	^ new! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'cwp 11/28/2004 12:56'!
element
	^ element! !

!MDElementDefinition methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ false! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'avi 12/2/2004 01:53'!
updateFrom: anImageProxy
	(anImageProxy hasElement: element) ifFalse: [^ MDElementRemoval forElement: element].
	element update: properties from: anImageProxy.
	^ self! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 3/2/2005 23:44'!
isUpToDateFor: anImageProxy
	^ (anImageProxy hasElement: element)
		and: [element is: properties upToDateFor: anImageProxy]! !

!MDElementDefinition class methodsFor: 'instance creation' stamp: 'cwp 11/28/2004 12:52'!
forElement: anElement
	^ self basicNew initializeWithElement: anElement! !

!MDElementDefinition methodsFor: 'initialize-release' stamp: 'cwp 11/29/2004 00:50'!
initializeWithElement: anElement
	element _ anElement.
	properties _ MDPropertyDictionary new! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 2/13/2005 19:41'!
isLoadableInto: anImageProxy
	^ element isLoadable: properties into: anImageProxy! !

!MDElementDefinition methodsFor: 'comparing' stamp: 'cwp 3/7/2005 17:22'!
= other
	^ self species = other species
		and: [self element = other element]
		and: [self properties = other properties]! !

!Object methodsFor: '*monticello2' stamp: 'cwp 3/7/2005 21:23'!
classId
	^ MDMarshal classIdForObject: self! !

Object subclass: #MDHashstamp
	instanceVariableNames: 'hash timestamp'
	classVariableNames: 'Epoch CharMap'
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 2/27/2005 17:30'!
hashIn: aBlock
	^ self hashIn: aBlock timestamp: TimeStamp now! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 2/27/2005 17:34'!
= other
	self class = other class ifFalse: [^ false].
	self hash = other hash ifFalse: [^ false].
	^ self timestamp = other timestamp! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 2/27/2005 17:17'!
hash
	^ hash! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 3/9/2005 23:01'!
setHash: aLargeInteger timestamp: aTimeStamp
	hash _ aLargeInteger withAtLeastNDigits: 20.
	timestamp _ aTimeStamp! !

!MDHashstamp class methodsFor: 'serializing' stamp: 'cwp 3/11/2005 23:30'!
decodeString: aString
	| write read a b c d |
	write _ (ByteArray new: 24) writeStream.
	read _ aString readStream.
	[read atEnd] whileFalse:
		[a _ (CharMap indexOf: read next) - 1.
		b _ (CharMap indexOf: read next) - 1.
		write nextPut: (a bitShift: 2) + (b bitShift: -4).
		b _ b bitAnd: 16rF.
		c _ (CharMap indexOf: read next) - 1.
		write nextPut: (b bitShift: 4) + (c bitShift: -2).
		c _ c bitAnd: 16r3.
		d _ (CharMap indexOf: read next) - 1.
		write nextPut: (c bitShift: 6) + d].
	^ write contents! !

!MDHashstamp class methodsFor: 'constants' stamp: 'avi 3/12/2005 04:04'!
epoch
	^ Epoch! !

!MDHashstamp methodsFor: 'printing' stamp: 'cwp 3/10/2005 01:00'!
printOn: aStream
	| bytes |
	bytes _ MDMarshal serialize: self.
	2 to: 25 by: 3 do: [:i | self 
							printFirst: (bytes at: i) 
							second: (bytes at: i+1)
							third: (bytes at: i+2)
							on: aStream].! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 2/27/2005 17:17'!
timestamp
	^ timestamp! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 3/9/2005 20:42'!
serializeWith: aMarshal
	aMarshal writeHashstamp: self! !

!MDHashstamp class methodsFor: 'initialize-release' stamp: 'avi 3/12/2005 04:04'!
initialize
	CharMap _ '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-+'.
	Epoch _ TimeStamp year: 1980 day: 1 hour: 0 minute: 0 second: 0! !

!MDHashstamp class methodsFor: 'serializing' stamp: 'cwp 3/9/2005 21:07'!
materializeWith: aMarshal
	^ aMarshal readHashstamp: (self basicNew)! !

!MDHashstamp methodsFor: 'printing' stamp: 'cwp 3/10/2005 00:45'!
printFirst: first second: second third: third on: aStream
	| a b c d |
	a _ first bitShift: -2.
	b _ ((first bitShift: 4) bitOr: (second bitShift: -4)) bitAnd: 16r3F.
	c _ ((second bitShift: 2) bitOr: (third bitShift: -6)) bitAnd: 16r3F.
	d _ third bitAnd: 16r3F.
	
	aStream
		nextPut: (CharMap at: a+1);
		nextPut: (CharMap at: b+1);
		nextPut: (CharMap at: c+1);
		nextPut: (CharMap at: d+1)! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'avi 3/12/2005 03:18'!
fromString: aString
	^ (MDMarshal on: (self decodeString: aString) readStream)
		readHashstamp: MDHashstamp basicNew! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 3/9/2005 22:45'!
hashIn: aBlock timestamp: aTimestamp
	| sha stream |
	stream _ RWBinaryOrTextStream on: ByteArray new.
	aBlock value: (MDMarshal on: stream).
	sha _ SecureHashAlgorithm new.
	^ self new setHash: (sha hashMessage: stream contents) timestamp: aTimestamp! !

!AbstractString methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:13'!
serializeWith: aMarshal
	aMarshal writeString: self! !

!AbstractString class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:56'!
materializeWith: aMarshal
	^ aMarshal readStringOfClass: self! !

TestCase subclass: #MDAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 2/5/2005 20:53'!
tearDown
	self destroyObject! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 14:45'!
testIsLoadable
	self assert: (self adaptor isLoadable: self properties)
! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/12/2005 14:41'!
testNotUpToDate
	| properties |
	self propertyToChange ifNil: [^ self].
	self createObject.
	properties := self properties.
	properties at: self propertyToChange put: self changedValue.
	self deny: (self adaptor isUpToDate: properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 21:07'!
testNotPresent
	self deny: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:43'!
adaptor
	^ self adaptorForElement: self element! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 23:03'!
testUpdateSideEffects
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:49'!
bogusClass
	^ MDBogusA! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 23:54'!
testRemoveNotPresent
	self adaptor remove.
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 21:29'!
testIsUpToDate
	| method |
	self createObject.
	method := self adaptor.
	self assert: (method isUpToDate: self properties)! !

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2005 21:40'!
shouldInheritSelectors
	^ true! !

MDAdaptorTest subclass: #MDSqueakInstVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakInstVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 14:07'!
denyObjectIsPresent
	self deny: self objectIsPresent! !

!MDSqueakInstVarAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 13:06'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:05'!
destroyObject
	self objectIsPresent 
		ifTrue: [self bogusClass removeInstVarName: self instVarName]! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 12:26'!
element
	^ MDInstVarElement 
		className: self bogusClass name 
		name: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:24'!
createObject
	self bogusClass addInstVarName: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:05'!
objectIsPresent
	^self bogusClass instVarNames includes: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:02'!
adaptorClass
	^ MDSqueakInstVarAdaptor! !

!MDSqueakInstVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:56'!
assertObjectHasDefaultProperties
	self bogusClass instVarNames includes: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:21'!
instVarName
	^'two'! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	"An instance variable has no properties, thus it is always up-to-date"

	^ nil! !

MDSqueakInstVarAdaptorTest subclass: #MDSqueakClassInstVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/4/2005 15:05'!
adaptor
	^ MDSqueakClassInstVarAdaptor forElement: self element! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/4/2005 15:13'!
element
	^ MDClassInstVarElement 
		className: self bogusClass theNonMetaClass name 
		name: self instVarName! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constants' stamp: 'cwp 3/4/2005 14:54'!
instVarName
	^ 'beth'! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'accessing' stamp: 'cwp 3/4/2005 14:54'!
bogusClass
	^ super bogusClass class! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:02'!
unloadableElement
	^ MDInstVarElement 
		className: #MDNonExistentClass
		name: self instVarName! !

MDAdaptorTest subclass: #MDSqueakClassAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 11:55'!
assertObjectHasDefaultProperties
	| class |
	class := Smalltalk 
			at: self bogusClassName 
			ifAbsent: [self signalFailure: 'Class doesn''t exist'].
	self assert: class superclass name = self superclassName.
	self assert: class category = self category.
	self assert: class typeOfClass = self format! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 12:03'!
category
	^ #'Monticello2-Fakes'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:15'!
commentStamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/12/2005 14:45'!
propertyToChange
	^ #category! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:18'!
properties
	^ MDPropertyDictionary new
		category: self category;
		format: self format;
		superclassName: self superclassName;
		yourself! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:14'!
commentTimeStamp
	^ TimeStamp fromMethodTimeStamp: self commentStamp! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/12/2005 15:05'!
changedValue
	^ #temp! !

!MDSqueakClassAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 16:06'!
testClassMissing
	| properties |
	properties _ self properties.
	properties superclassName: #MDNonExistentClass.
	self deny: (self adaptor isLoadable: properties)! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:16'!
classInstVars
	^ 'aleph beth'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 21:36'!
format
	^ #normal! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:06'!
objectIsPresent
	^ Smalltalk hasClassNamed: self bogusClassName asString! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:07'!
classVariablesString
	^ 'Alpha Beta'! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:02'!
bogusClassName
	^ #MDBogusB! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 11:56'!
destroyObject
	(Smalltalk at: self bogusClassName ifAbsent: [^ self]) removeFromSystem! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:07'!
instanceVariablesString
	^'one two'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 21:36'!
superclassName
	^ #Object! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:08'!
createObject
	Object 
		subclass: self bogusClassName
		instanceVariableNames: self instanceVariablesString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!MDSqueakClassAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 12:05'!
testLoadingPreservesVars
	| class |
	self createObject.
	self adaptor load: self properties.
	class := Smalltalk at: self bogusClassName ifAbsent: [self assert: false].
	self assert: class instanceVariablesString = 'one two'.
	self assert: class classVariablesString = 'Alpha Beta'.
	self assert: class sharedPoolsString = self sharedPoolsString.! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:14'!
commentAuthor
	^ self commentStamp copyUpTo: $ ! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:12'!
classVars
	^ 'Alpha Beta'! !

!MDSqueakClassAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 11:58'!
element
	^ MDClassElement className: self bogusClassName! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:13'!
comment
	^ 'A politician''s comment: it fills the space, while saying nothing.'! !

!MDSqueakClassAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:42'!
adaptorClass
	^ MDSqueakClassAdaptor ! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 23:52'!
sharedPoolsString
	^ 'MDBogusPoolA'! !

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 11:53'!
isAbstract
	^ self name = #MDAdaptorTest! !

MDAdaptorTest subclass: #MDSqueakMethodAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakMethodAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 20:43'!
testSourceAsString
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: (properties source isKindOf: String)! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 11:52'!
createObject
	self bogusClass
		compile: self source
		classified: self category
		withStamp: self stamp
		notifying: nil
		logSource: true! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:25'!
stamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:49'!
propertyToChange
	^ #category! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:06'!
changedValue
	^ #temp! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:24'!
category
	^ #temporary! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:39'!
properties
	^ MDPropertyDictionary new
		author: self author;
		category: self category;
		source: self source;
		timeStamp: self timeStamp;
		yourself! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:07'!
objectIsPresent
	^self bogusClass includesSelector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 12:16'!
element
	^ MDMethodElement className: self bogusClass name selector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:00'!
adaptorClass
	^ MDSqueakMethodAdaptor! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:23'!
source
	^ 'method1
	^ 1'! !

!MDSqueakMethodAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:14'!
theSelector
	^#method1! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 15:58'!
unloadableElement
	^ MDMethodElement className: #MDNonExistentClass selector: #foo! !

MDSqueakMethodAdaptorTest subclass: #MDSqueakClassMethodAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassMethodAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2005 15:21'!
element
	^ MDMethodElement 
		className: super bogusClass name
		selector: self theSelector
		classIsMeta: true! !

!MDSqueakClassMethodAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2005 15:14'!
bogusClass
	^ super bogusClass class! !

!MDSqueakMethodAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:15'!
assertObjectHasDefaultProperties
	self assert: (self bogusClass includesSelector: self theSelector).
	self assert: (self bogusClass organization categoryOfElement: self theSelector) = self category.
	self assert: (self bogusClass sourceCodeAt: self theSelector) = self source.
	self assert: (self bogusClass compiledMethodAt: self theSelector) timeStamp = self stamp! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:15'!
destroyObject
	self bogusClass removeSelector: self theSelector! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 15:55'!
testClassMissing
	| adaptor |
	adaptor := self adaptorForElement: self unloadableElement.
	self deny: (adaptor isLoadable: self properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 14:08'!
testRemove
	self createObject.
	self adaptor remove.
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 22:54'!
testUpdate
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: properties = self properties! !

MDAdaptorTest subclass: #MDSqueakClassCommentAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 14:27'!
createObject
	self bogusClass classComment: self text stamp: self stamp
! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:20'!
element
	^ MDClassCommentElement className: self bogusClass name! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 20:54'!
testTextAsString
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: (properties text isKindOf: String)! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:36'!
properties
	^ MDPropertyDictionary new
		at: #text put: self text;
		at: #author put: self author;
		at: #timeStamp put: self timeStamp;
		yourself! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:45'!
propertyToChange
	^ #text! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/12/2005 14:57'!
assertObjectHasDefaultProperties
	self assert: self bogusClass comment = self text.
	self assert: self bogusClass organization commentStamp = self stamp.! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
text
	^ 'A comment for MDBogusA'! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 15:00'!
destroyObject
	self bogusClass organization classComment: nil stamp: nil! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 14:59'!
objectIsPresent
	^ self bogusClass hasComment! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 15:39'!
adaptorClass
	^ MDSqueakClassCommentAdaptor! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:18'!
stamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:51'!
changedValue
	^ 'A different comment for MDBogusA.'! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:06'!
unloadableElement
	^MDClassCommentElement className: #MDNonExistentClass! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:41'!
adaptorClass
	self subclassResponsibility! !

MDAdaptorTest subclass: #MDSqueakClassVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:46'!
propertyToChange
	"Class variables have no properties and thus can never by out of date."

	^ nil 
	! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:04'!
objectIsPresent
	^self bogusClass classVarNames includes: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 14:04'!
assertObjectHasDefaultProperties
	self assert: self objectIsPresent! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:32'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:04'!
destroyObject
	self objectIsPresent 
		ifTrue: [self bogusClass removeClassVarName: self classVarName]! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:32'!
classVarName
	^ 'Beta'! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 13:31'!
createObject
	self bogusClass addClassVarName: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:46'!
element
	^ MDClassVarElement 
		className: self bogusClass name 
		name: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:00'!
adaptorClass
	^ MDSqueakClassVarAdaptor! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:01'!
unloadableElement
	^ MDClassVarElement className: #MDNonExistentClass name: #Foo! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
timeStamp
	^ TimeStamp fromMethodTimeStamp: self stamp! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
author
	^ self stamp copyUpTo: $ ! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 15:17'!
testLoad
	self adaptor load: self properties.
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 2/15/2005 15:56'!
unloadableElement
	self subclassResponsibility! !

MDAdaptorTest subclass: #MDSqueakPoolImportAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakPoolImportAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:57'!
pool
	^ Smalltalk at: self poolName! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:49'!
propertyToChange
	"A pool import has no properties and is thus always up-to-date."
	^ nil! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:06'!
unloadableElement
	^ MDPoolImportElement className: #MDNonExistentClass poolName: #Foo! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:04'!
adaptorClass
	^ MDSqueakPoolImportAdaptor! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:37'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:59'!
poolName
	^ #MDBogusPoolB! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 22:56'!
createObject
	self bogusClass addSharedPool: self pool! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 23:09'!
destroyObject
	self bogusClass sharedPools remove: self pool ifAbsent: []! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 23:45'!
assertObjectHasDefaultProperties
	self assert: (self bogusClass sharedPools anySatisfy: [:ea | ea name = self poolName])! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 23:46'!
objectIsPresent
	^ self bogusClass sharedPools anySatisfy: [:ea | ea name = self poolName]! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 23:30'!
element
	^ MDPoolImportElement className: self bogusClass name poolName: self poolName! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:41'!
adaptorForElement: anElement
	^ self adaptorClass forElement: anElement! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:42'!
testIsPresent
	self createObject.
	self assert: self adaptor isPresent! !

TestCase subclass: #MDTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:32'!
removal: aSymbol
	^ MDElementRemoval forElement: (self element: aSymbol)! !

MDTestCase subclass: #MDSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:41'!
testSnapshot
	self assertEqualityOf: self snapshot ! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:21'!
testInstVarElement
	self assertEqualityOf: (MDInstVarElement className: #MDBogusA name: 'one')! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:23'!
testMethodElement
	self assertEqualityOf: (MDMethodElement className: #MDBogusA selector: #one)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:22'!
testClassInstVarElement
	self assertEqualityOf: (MDClassInstVarElement className: #MDBogusA name: 'beth')! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 17:21'!
testElementDefinition
	self assertEqualityOf: self definition! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 17:22'!
testString
	self assertEqualityOf: 'abc'.! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:20'!
testClassCommentElement
	self assertEqualityOf: (MDClassCommentElement className: #MDBogusA)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:27'!
testOneByteInteger
	self assertEqualityOf: 7! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/12/2005 01:06'!
testOneSecondToMidnight
	| ts buffer |
	ts _ MDHashstamp epoch plusSeconds: 86399.
	buffer _ MDMarshal serialize: ts.
	self assert: buffer  = #(8 0 1 81 127) asByteArray.
	self assert: (MDMarshal materialize: buffer) = ts! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/12/2005 00:22'!
testHashstampEpoch
	self assert: (MDMarshal serialize: MDHashstamp epoch) = #(8 0 0 0 0) asByteArray! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 21:34'!
testUnrecognizedClass
	self
		should: [MDMarshal serialize: 'abc' asText]
		raise: Error! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:20'!
testClassElement
	self assertEqualityOf: (MDClassElement className: #MDBogusA)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 15:35'!
testFakeElement
	self assertEqualityOf: self element! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 17:15'!
testSymbol
	self assertEqualityOf: #one using: [:before :after | self assert: before == after]! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/8/2005 00:22'!
assertEqualityOf: anObject using: aBlock 
	| other buffer |
	buffer := MDMarshal serialize: anObject.
	other := MDMarshal materialize: buffer.
	aBlock value: anObject value: other! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:45'!
testLongString
	| string |
	string _ String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/9/2005 22:52'!
testHashstamp
	self assertEqualityOf: (MDHashstamp hashIn: [:marshal | marshal serialize: 'abc'])! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:26'!
testPoolImportElement
	self assertEqualityOf: (MDPoolImportElement className: #MDBogusA poolName: #MDBogusPoolA)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/9/2005 21:45'!
testClassMethodElement
	self assertEqualityOf: (MDMethodElement 
							className: #MDBogusA 
							selector: #one 
							classIsMeta: true)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:58'!
testPropertyDictionary
	| properties |
	properties _ MDPropertyDictionary new.
	properties
		first: 1;
		second: 'two'.
	self assertEqualityOf: properties! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:44'!
testTwoByteInteger
	self assertEqualityOf: 355! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 20:06'!
testMultiString
	self assertEqualityOf: (MultiString fromString: 'abc').! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:21'!
testClassVarElement
	self assertEqualityOf: (MDClassVarElement className: #MDBogusA name: 'Alpha')! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/4/2005 17:39'!
assertEqualityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after = before]! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 18:04'!
testVersion
	self 
		assertEqualityOf: self version 
		using: [:before :after |
				self assert: before snapshot = after snapshot.
				self assert: before hashstamp = after hashstamp.
				self assert: before ancestry = after ancestry]! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/12/2005 01:06'!
testTheDayAfter
	| ts buffer |
	ts _ MDHashstamp epoch plusDays: 1.
	buffer _ MDMarshal serialize: ts.
	self assert: buffer  = #(8 0 2 0 0) asByteArray.
	self assert: (MDMarshal materialize: buffer) = ts! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 17:04'!
testElementRemoval
	self assertEqualityOf: self removal.! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:32'!
definition
	^ MDElementDefinition forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:30'!
versionFor: elementName with: value
	| element snapshot |
	element _ MDFakeElement named: elementName.
	snapshot _ MDElementDefinition forElement: element.
	snapshot properties at: #foo put: value.
	^ MDElementVersion snapshot: snapshot! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:32'!
removal
	^ MDElementRemoval forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
elements
	^ Set
		with: (MDFakeElement named: #Alpha)
		with: (MDFakeElement named: #Beta)! !

MDTestCase subclass: #MDProxyTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDProxyTest methodsFor: 'configuration' stamp: 'cwp 2/4/2005 23:58'!
proxyClass
	^ MDFakeImageProxy! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/4/2005 23:54'!
atElement: element property: property put: value
	"This will need to be overriden in tests that use a real image proxy."
	
	(proxy at: element) at: property put: value! !

MDProxyTest subclass: #MDSliceTest
	instanceVariableNames: 'wc repository snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSliceTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 21:26'!
loadRepository
	repository
		put: (self versionFor: #Alpha with: 'alpha');
		put: (self versionFor: #Beta with: 'beta').! !

!MDSliceTest methodsFor: 'running' stamp: 'cwp 3/10/2005 23:26'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.
! !

!MDSliceTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:28'!
prepare
	self prepare: 
		[self addToBoth: (self versionFor: #Alpha with: 'alpha').
		self addToBoth: (self versionFor: #Beta with: 'beta')].
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:38'!
testLoadLargerSnapshot
	| slice alpha beta |
	self prepare.
	alpha _ self element: #Alpha.
	beta _ self element: #Beta.
	slice _ MDExplicitSlice new.
	slice addElement: alpha.
	slice load: snapshot from: repository to: wc.
	self assert: (self atElement: alpha property: #foo) = 'alpha'.
	self assert: (self atElement: beta property: #foo) = 'beta'.
	self assert: slice elements size = 1! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:37'!
testLoadEqualSnapshot
	self prepare.
	self slice load: snapshot from: repository to: wc.
	self assert: (self atElement: (self element: #Alpha) property: #foo) = 'alpha'.
	self assert: (self atElement: (self element: #Beta) property: #foo) = 'beta'.! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:35'!
testSnapshot
	| slice versions |
	self prepare: [].
	slice _ self slice.
	snapshot _ slice saveFrom: wc to: repository.
	versions _ snapshot getVersionsFrom: repository.
	slice do: 
		[:element |
		self assert: (versions anySatisfy: [:version | version element = element])].
	self deny: (repository get: snapshot hashstamp) isNil! !

!MDSliceTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
prepare: aBlock
	| repositoryVersions |
	repository _ Set new.
	snapshot _ Set new.
	aBlock value.
	repositoryVersions _ repository.
	repository _ MDMemoryRepository new.
	repositoryVersions do: [:ea | repository put: ea].
	snapshot _ MDSnapshot buildIn: [:properties :versions | versions addAll: snapshot].
	
	! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:31'!
testLoadSmallerSnapshot
	self prepare: [self addToBoth: (self versionFor: #Alpha with: 'alpha')].
	self slice load: snapshot from: repository to: wc.
	self assert: (self atElement: (self element: #Alpha) property: #foo) = 'alpha'.
	self assert: (self atElement: (self element: #Beta) property: #foo) isNil.
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:34'!
testLoadWithDepenencies
	self prepare:
		[self addToBoth: (self versionFor: #Alpha with: 'alpha').
		self addToBoth: (self versionFor: #Beta with: 'beta').
		self addToBoth: (self versionFor: #'Alpha/Delta' with: 'ad')].

	self slice load: snapshot from: repository to: wc.
	self
		assert: (self atElement: (self element: #Alpha) property: #foo) = 'alpha';
		assert: (self atElement: (self element: #Beta) property: #foo) = 'beta';
		assert: (self atElement: (self element: #'Alpha/Delta') property: #foo) = 'ad'.! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:37'!
testIncludeSnapshot
	self prepare.
	[self slice include: snapshot from: repository in: wc]
		on: MDMergeRequest
		do: [:merge | merge versions do: [:ea | merge workingCopy loadVersion: ea]].
			
	self assert: (self atElement: (self element: #Alpha) property: #foo) = 'alpha'.
	self assert: (self atElement: (self element: #Beta) property: #foo) = 'beta'.! !

!MDSliceTest methodsFor: 'constructing' stamp: 'cwp 2/27/2005 21:43'!
slice
	^ MDExplicitSlice new
		addElement: (self element: #Alpha);
		addElement: (self element: #Beta);
		yourself
	! !

!MDSliceTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToSnapshot: aVersion
	snapshot add: aVersion! !

!MDSliceTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToRepository: aVersion
	repository add: aVersion! !

!MDSliceTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:26'!
addToBoth: aVersion
	snapshot add: aVersion.
	repository add: aVersion! !

!MDProxyTest class methodsFor: 'testing' stamp: 'abc 2/13/2005 12:37'!
isAbstract
	^ self name = #MDProxyTest! !

MDProxyTest subclass: #MDWorkingCopyTest
	instanceVariableNames: 'wc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/13/2005 20:06'!
testSaveFirstVersion
	| version |
	self atElement: self element property: #foo put: 'one'.
	version _ wc versionForElement: self element.
	self assert: version ancestry isEmpty.
	self assert: version snapshot properties foo = 'one'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testIncludeOldVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	wc loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #source) = 'two'.
! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 15:30'!
testSingleton
	self assert: MDWorkingCopy default == MDWorkingCopy default! !

!MDWorkingCopyTest methodsFor: 'asserting' stamp: 'cwp 3/2/2005 23:49'!
assertNoConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | self assert: false. ^self]! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/27/2005 21:56'!
testIncludeAbsentVersion
	| version |
	version _ self version.
	version snapshot properties foo: 'bar'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #foo) = 'bar'! !

!MDWorkingCopyTest methodsFor: 'asserting' stamp: 'cwp 3/2/2005 23:49'!
assertConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | ^ self].
	self assert: false! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:40'!
testLoadDeleteAndSave
	| version newVersion |
	version := self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	proxy removeKey: version element.
	newVersion := wc versionForElement: version element.
	wc loadVersion: newVersion.
	self deny: (proxy includesKey: version element)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testIncludeNewVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	self assertNoConflictIncluding: newVersion.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkingCopyTest methodsFor: 'running' stamp: 'avi 11/29/2004 12:52'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:12'!
testIncludeConflictingVersion
	| version newVersion newVersion2 |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	newVersion2 _ self updateVersion: version property: #source put: 'three'.
	wc loadVersion: newVersion.
	self assertConflictIncluding: newVersion2! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/28/2005 21:45'!
testLoadModifyAndSave
	| version newVersion |
	version := self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version.
	self atProperty: #source put: 'two'.
	newVersion := wc versionForElement: version element.
	self deny: newVersion == version.
	self assert: (newVersion succeeds: version)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:18'!
testModifyAndIncludeConflictingVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	self atProperty: #source put: 'three'.
	self assertConflictIncluding: newVersion! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/13/2005 20:05'!
testLoadAndSave
	| version |
	version _ self version.
	version snapshot properties foo: '1'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testLoad
	| version |
	version _ self version.
	version snapshot properties foo: 'bar'.
	wc loadVersion: version.
	self assert: (self atProperty: #foo) = 'bar'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:25'!
testLoadModifySaveAndSave
	| version newVersion newVersion2 |
	version := self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version.
	self atProperty: #source put: 'two'.
	newVersion := wc versionForElement: version element.
	newVersion2 := wc versionForElement: version element.
	self assert: newVersion == newVersion2! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/28/2005 21:45'!
testSaveAbsentVersion
	| saved constructed |
	saved := wc versionForElement: self element.
	constructed := self versionFor: #Alpha with: 'alpha'.
	self assert: saved ancestry isEmpty.
	self assert: (constructed succeeds: saved)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:17'!
testLoadOldVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	wc loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	wc loadVersion: version.
	self assert: (self atProperty: #source) = 'one'.
! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:51'!
testResolveConflict
	| version newVersion newVersion2 mergedVersion |
	version := self version.
	version snapshot properties source: 'one'.
	newVersion := self 
				updateVersion: version
				property: #source
				put: 'two'.
	newVersion2 := self 
				updateVersion: version
				property: #source
				put: 'three'.
	wc loadVersion: newVersion.
	wc 
		includeVersion: newVersion2 
		onConflict: [:a :b | 
					self assert: a snapshot properties source = 'two'.
					b snapshot].
	self assert: (self atProperty: #source) = 'three'.
	mergedVersion := wc versionForElement: version element.
	self assert: mergedVersion snapshot = newVersion2 snapshot.
	self assert: (mergedVersion succeeds: newVersion).
	self assert: (mergedVersion succeeds: newVersion2)! !

MDProxyTest subclass: #MDImageProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:38'!
testLoadAndUpdate
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	
	retrieved _ proxy updateSnapshot: self definition.
	self assert: original properties = retrieved properties! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:45'!
testRemoval
	| snap |
	self atElement: self element property: #foo put: 'bar'.
	snap _ self removal.
	proxy loadSnapshot: snap.
	self assert: (self atElement: self element property: #foo) isNil! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/13/2005 19:50'!
testNotLoadable
	| snap |
	snap _ self definition: #'Alpha/Delta'.
	snap properties at: #one put: 1.
	self deny: (proxy isLoadable: snap)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:46'!
testRemovalUpToDate
	| snap removal |
	snap _ self definition.
	removal _ self removal.
	snap properties foo: 'bar'.
	proxy loadSnapshot: snap.
	self deny: (proxy isUpToDate: removal).
	proxy loadSnapshot: removal.
	self assert: (proxy isUpToDate: removal)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:43'!
testLoadDefinition
	| snap |
	snap _ self definition.
	snap properties 
			at: #one put: 1;
			at: #two put: 2;
			at: #three put: 3.
	proxy loadSnapshot: snap.
	self assert: (self atElement: self element property: #one) = 1.
	self assert: (self atElement: self element property: #two) = 2.
	self assert: (self atElement: self element property: #three) = 3.! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:39'!
testLoadAndUpdateRemoval
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	retrieved _ proxy updateSnapshot: self removal.
	self assert: retrieved properties = original properties! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:47'!
testUpToDate
	| snap |
	snap _ self definition.
	snap properties source: 'one ^ 1'.
	proxy loadSnapshot: snap.
	self assert: (proxy isUpToDate: snap).
	self atElement: self element property: #source put: 'one ^ 11'.
	self deny: (proxy isUpToDate: snap).! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:52'!
testCurrentDefinition
	| snap |
	self atElement: self element property: #one put: 1.
	snap := self definition.
	proxy updateSnapshot: snap.
	self assert: (snap properties at: #one) = 1
! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:44'!
testLoadRemoveAndUpdate
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	proxy loadSnapshot: self removal.
	retrieved _ proxy updateSnapshot: self definition.
	self assert: retrieved element = self element.
	self assert: retrieved isRemoval! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/13/2005 19:36'!
testIsLoadable
	| snap |
	snap _ self definition.
	snap properties at: #one put: 1.
	self assert: (proxy isLoadable: snap)! !

!MDImageProxyTest methodsFor: 'tests' stamp: ''!
testRemovalLoadable
	| snap |
	snap _ self removal: #'Alpha/Delta'.
	self assert: (proxy isLoadable: snap)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:47'!
testUpdateDoesntChangeElement
	| snap original |
	snap := self definition.
	original := snap element.
	proxy updateSnapshot: snap.
	self assert: snap element = original! !

!MDProxyTest methodsFor: 'running' stamp: 'avi 11/29/2004 12:49'!
setUp
	proxy _ self proxyClass new! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:16'!
atProperty: aSymbol
	^ self atElement: self element property: aSymbol! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/27/2005 20:58'!
atElement: element property: property
	^ (proxy at: element) at: property ifAbsent: [nil]! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:17'!
atProperty: aSymbol put: aValue
	self atElement: self element property: aSymbol put: aValue
! !

!MDTestCase class methodsFor: 'as yet unclassified' stamp: 'cwp 3/2/2005 22:35'!
isAbstract
	^ self name = #MDTestCase! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
updateVersion: anElementVersion property: aSymbol put: anObject
	| newSnapshot |
	newSnapshot _ anElementVersion snapshot copy.
	newSnapshot properties at: aSymbol put: anObject.
	^ MDElementVersion
		snapshot: newSnapshot
		ancestry: anElementVersion fullAncestry! !

!MDTestCase methodsFor: 'asserting' stamp: 'cwp 3/2/2005 22:51'!
fail
	self signalFailure: 'Assertion failed'! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:09'!
snapshot
	^ self snapshot: [:versions | ].
! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:32'!
definition: aSymbol
	^ MDElementDefinition forElement: (self element: aSymbol)! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:10'!
snapshot: aBlock
	^ MDSnapshot buildIn:
		[:properties :versions | 
		versions 
			add: (self versionFor: #Alpha with: 'alpha');
			add: (self versionFor: #Beta with: 'beta')	.
		aBlock value: versions].! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element
	^ self element: #Alpha! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:32'!
version
	^ MDElementVersion snapshot: self definition! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element: aSymbol
	^ MDFakeElement named: aSymbol! !

MDTestCase subclass: #MDAncestryTest
	instanceVariableNames: 'parent child'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 15:20'!
testChildSuccessorSibling
	| result merged sibling |
	sibling := self sibling.
	merged := child successor: sibling
				onConflict: 
					[result := self definition.
					result properties at: #merged put: true.
					result].
	self assert: (merged succeeds: child).
	self assert: (merged succeeds: sibling).
	self assert: merged snapshot properties merged! !

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 3/2/2005 23:15'!
null
	^ MDNullVersion forElement: self element! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:46'!
testParentConflictsWithChild
	self deny: (parent conflictsWith: child).! !

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:55'!
sibling
	^self 
		updateVersion: parent
		property: #bar
		put: 'bar'! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:19'!
testChildSuccessorParent
	self assert: (child successor: parent onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:19'!
testParentSuccessorChild
	self assert: (parent successor: child onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildSucceedsParent
	self assert: (child succeeds: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 00:00'!
testSiblingSucceedsChild
	self deny: (self sibling succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:18'!
testNullSuccessorChild
	self assert: (child successor: self null onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testNullPrecedesChild
	self assert: (self null precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testChildConflictsWithSibling
	self assert: (child conflictsWith: self sibling)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildConflictsWithParent
	self deny: (child conflictsWith: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildPrecedesParent
	self deny: (child precedes: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentPrecedesChild
	self assert: (parent precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:15'!
testSiblingConflictsWithChild
	self assert: (self sibling conflictsWith: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:17'!
testChildPreceedsNull
	self deny: (child precedes: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:18'!
testChildSuccessorNull
	self assert: (child successor: self null onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'running' stamp: 'cwp 3/2/2005 22:46'!
setUp
	parent := self version.
	child := self 
				updateVersion: parent
				property: #foo
				put: 'alpha2'! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:59'!
testSiblingPreceedsChild
	self deny: (self sibling precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testChildSucceedsNull
	self assert: (child succeeds: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentSucceedsChild
	self deny: (parent succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testNullSucceedsChild
	self deny: (self null succeeds: child)! !

TestCase subclass: #MDHashstampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 3/9/2005 22:50'!
testCreation
	| hashstamp |
	hashstamp _ MDHashstamp hashIn: [:marshal | marshal serialize: 'abc'].
	self assert: hashstamp hash digitLength = 20.
	self assert: (DateAndTime now - hashstamp timestamp) asSeconds < 5.! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 3/9/2005 23:35'!
testHash
	| first second |
	first _ MDHashstamp hashIn: [:marshal | marshal serialize: 'abc'].
	second _ MDHashstamp hashIn: [:marshal | marshal serialize: 'bcd'].
	self deny: first hash = second hash.
	self deny: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 01:07'!
testPrinting
	| hashstamp |
	hashstamp _ MDHashstamp 
					hashIn: [:marshal | marshal serialize: 'abc']
					timestamp: (MDHashstamp epoch plusSeconds: 30000).
	self assert: hashstamp printString = 'seMXphGVbz79tmSDlHVNuvUQWM0007kM'! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 3/9/2005 22:47'!
testTimestamp
	| first second now then |
	now _ DateAndTime now.
	then _ now - (Duration seconds: 1).
	first _ MDHashstamp hashIn: [:marshal | marshal serialize: 'abc'] timestamp: then.
	second _ MDHashstamp hashIn: [:marshal | marshal serialize: 'abc'] timestamp: now.
	self assert: first hash = second hash.
	self deny: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 3/9/2005 22:46'!
testEqual
	| first second now |
	now _ TimeStamp now.
	first _ MDHashstamp hashIn: [:marshal | marshal serialize: 'abc'] timestamp: now.
	second _ MDHashstamp hashIn: [:marshal | marshal serialize: 'abc'] timestamp: now.
	self assert: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'avi 3/12/2005 03:03'!
testRead
	| hashstamp |
	hashstamp _ MDHashstamp hashIn: [:marshal | marshal serialize: 'abc'].
	self assert: hashstamp = (MDHashstamp fromString: hashstamp asString)
! !

TestCase subclass: #MDAdaptionTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDAdaptionTest subclass: #MDFakeAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDFakeAdaptionTest methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:32'!
proxyClass
	^ MDFakeImageProxy! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 23:59'!
testPoolImportElement
	self tryAdapting: (MDPoolImportElement className: #MDBogusA poolName: #MDBogusPoolB)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:27'!
testInstVarElement
	self tryAdapting: (MDInstVarElement className: #MDBogusA name: 'one')! !

!MDAdaptionTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 22:14'!
adaptorSelectors
	^ #(isPresent isUpToDate: load: remove update:)! !

!MDAdaptionTest methodsFor: 'configuration' stamp: 'cwp 2/6/2005 22:10'!
proxyClass
	^ MDFakeImageProxy! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:26'!
testClassElement
	self tryAdapting: (MDClassElement className: #MDBogusA)! !

!MDAdaptionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 22:33'!
isAbstract
	^ self name = #MDAdaptionTest! !

!MDAdaptionTest methodsFor: 'running' stamp: 'cwp 2/6/2005 22:26'!
tryAdapting: anElement
	| adaptor |
	adaptor := anElement adaptedFor: proxy.
	self adaptorSelectors do: [:ea | self assert: (adaptor respondsTo: ea)].! !

!MDAdaptionTest methodsFor: 'running' stamp: 'cwp 2/6/2005 22:37'!
setUp
	proxy := self proxyClass new! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/12/2005 13:59'!
testClassComment
	self tryAdapting: (MDClassCommentElement className: #MDBogusA)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 14:43'!
testClassInstVarElement
	self tryAdapting: (MDClassInstVarElement className: #MDBogusA name: 'beth')! !

MDAdaptionTest subclass: #MDSqueakAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakAdaptionTest methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:33'!
proxyClass
	^ MDSqueakImageProxy! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:26'!
testMethodElement
	self tryAdapting: (MDMethodElement className: #MDBogusA selector: #method1)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:29'!
testClassVarElement
	self tryAdapting: (MDClassVarElement className: #MDBogusA name: 'Beta')! !

TestCase subclass: #MDRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDRepositoryTest methodsFor: 'tests' stamp: 'avi 3/12/2005 02:39'!
testStoreSnapshot
	| repository snapshot |
	repository _ self newRepository.
	snapshot _ self snapshot.
	repository put: snapshot.
	self assert: (repository get: snapshot hashstamp) isEquivalentTo: snapshot! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 02:38'!
snapshot
	^ MDSnapshot buildIn:
		[:properties :versions |
		versions add: self version]! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'avi 3/12/2005 02:39'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	^ (MDMarshal serialize: anElementVersion) = (MDMarshal serialize: otherElementVersion)! !

!MDRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2005 00:46'!
isAbstract
	^ self name = #MDRepositoryTest! !

MDRepositoryTest subclass: #MDMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:46'!
newRepository
	^ MDMemoryRepository new! !

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 02:39'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	^ anElementVersion == otherElementVersion! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:45'!
newRepository
	self subclassResponsibility! !

MDRepositoryTest subclass: #MDDirectoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2005 00:50'!
newRepository
	^ MDDirectoryRepository new! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'avi 3/12/2005 02:39'!
testStoreVersion
	| repository version |
	repository _ self newRepository.
	version _ self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:45'!
version
	^ MDElementVersion 
		snapshot: (MDElementDefinition 
					forElement: (MDFakeElement 
									named: #Alpha))! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'avi 3/12/2005 03:23'!
testHashstampsForClass
	| repository version snapshot versionStamps snapshotStamps |
	repository _ self newRepository.
	version _ self version.
	snapshot _ self snapshot.

	repository put: version; put: snapshot.

	versionStamps _ Array streamContents:
						[:s | repository hashstampsForClass: version class do: [:ea | s nextPut: ea]].
	snapshotStamps _  Array streamContents:
						[:s | repository hashstampsForClass: snapshot class do: [:ea | s nextPut: ea]].

	self assert: (versionStamps includes: version hashstamp).
	self assert: (snapshotStamps includes: snapshot hashstamp).
	self deny: (versionStamps includes: snapshot hashstamp).
	self deny: (snapshotStamps includes: version hashstamp)! !

TestCase subclass: #MDPackageSliceTest
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDPackageSliceTest commentStamp: 'cwp 3/3/2005 02:10' prior: 0!
This comment needs to be here, or #testComment won't pass.!

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 3/3/2005 02:21'!
methods
	^ Array
		with: (MethodReference class: MDPackageSliceTest selector: #classes)
		with: (MethodReference class: MDPackageSliceTest selector: #methods)
		with: (MethodReference class: MDPackageSliceTest class selector: #bogusMethodA)
		with: (MethodReference class: MDPackageSliceTest class selector: #bogusMethodB)
! !

!MDPackageSliceTest methodsFor: 'asserting' stamp: 'cwp 3/3/2005 01:28'!
assertAll: labels includedAs: aBlock
	| expected |
	expected := labels collect: aBlock.
	self assert: (elements includesAllOf: expected)! !

!MDPackageSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 01:29'!
testClasses
	self
		assertAll: #(MDBogusA MDPackageSliceTest)
		includedAs: [:name | MDClassElement className: name].
! !

!MDPackageSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/3/2005 02:14'!
bogusMethodA
	"This method needs to be here for #testClassMethods to pass"! !

!MDPackageSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/3/2005 02:14'!
bogusMethodB
	"This method needs to be here for #testClassMethods to pass"! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 3/3/2005 00:59'!
classes
	^ Array with: MDBogusA with: self class! !

!MDPackageSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 01:37'!
testClassVar
	self 
		assertAll: #('Alpha')
		includedAs: [:name | MDClassVarElement 
							className: #MDBogusA 
							name: name]. 
		
! !

!MDPackageSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 01:57'!
testPoolImport
	self 
		assertAll: #('MDBogusPoolA')
		includedAs: [:name | MDPoolImportElement 
							className: #MDBogusA 
							poolName: name]. 
		
! !

!MDPackageSliceTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 15:24'!
testClassInstVar
	self 
		assertAll: #('aleph')
		includedAs: [:name | MDClassInstVarElement 
								className: #MDBogusA 
								name: name]. 
		
! !

!MDPackageSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 01:27'!
testMethods
	self 
		assertAll: #(classes methods)
		includedAs: [:sel | MDMethodElement 
							className: #MDPackageSliceTest 
							selector: sel]. 
		
! !

!MDPackageSliceTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 15:25'!
testInstVar
	self 
		assertAll: #('one')
		includedAs: [:name | MDInstVarElement 
								className: #MDBogusA 
								name: name]. 
		
! !

!MDPackageSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 02:14'!
testClassMethod
	self 
		assertAll: #(bogusMethodA bogusMethodB)
		includedAs: [:sel | MDMethodElement 
							className: #MDPackageSliceTest 
							selector: sel
							classIsMeta: true]. 
		
! !

!MDPackageSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 02:09'!
testComment

	self assert: (elements includes: (MDClassCommentElement 
									className: #MDPackageSliceTest))! !

!MDPackageSliceTest methodsFor: 'running' stamp: 'cwp 3/3/2005 01:15'!
setUp
	elements := (MDPackageSlice forPackage: self) elements
! !

!TimeStamp methodsFor: '*monticello2' stamp: 'cwp 3/12/2005 00:58'!
setJdn: julianDayNumber seconds: secs
	seconds _ secs.
	offset _ self class localOffset.
	jdn _ julianDayNumber.
	nanos _ 0! !

!TimeStamp methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:41'!
serializeWith: aMarshal
	aMarshal writeTimestamp: self! !

!TimeStamp class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:41'!
materializeWith: aMarshal
	^ aMarshal readTimestamp! !

!TimeStamp class methodsFor: '*monticello2' stamp: 'cwp 3/12/2005 00:55'!
fromJdn: julianDayNumber seconds: seconds
	^ self basicNew setJdn: julianDayNumber seconds: seconds! !

Dictionary subclass: #MDPropertyDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPropertyDictionary methodsFor: 'serializing' stamp: 'cwp 3/9/2005 20:18'!
serializeWith: aMarshal
	aMarshal writeDictionary: self! !

!MDPropertyDictionary methodsFor: 'convenience' stamp: 'cwp 11/29/2004 00:49'!
doesNotUnderstand: aMessage
	aMessage selector isUnary ifTrue: [^ self at: aMessage selector ifAbsent: [nil]].
	(aMessage selector isKeyword
		and: [aMessage arguments size = 1])
			ifTrue: [^ self
						at: aMessage selector allButLast asSymbol
						put: aMessage arguments first].
	super doesNotUnderstand: aMessage.! !

!MDPropertyDictionary class methodsFor: 'serializing' stamp: 'cwp 3/9/2005 21:17'!
materializeWith: aMarshal
	^ aMarshal readDictionaryOfClass: self! !

!Integer methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:14'!
serializeWith: aMarshal
	aMarshal writeSmallInteger: self! !

Notification subclass: #MDMergeRequest
	instanceVariableNames: 'versions wc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDMergeRequest methodsFor: 'initialize-release' stamp: 'cwp 2/28/2005 21:25'!
setVersions: aCollection workingCopy: aWorkingCopy
	versions _ aCollection.
	wc _ aWorkingCopy! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 2/28/2005 21:36'!
workingCopy
	^ wc! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 2/28/2005 21:37'!
versions
	^ versions! !

!MDMergeRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/28/2005 21:26'!
includeVersions: aCollection in: aWorkingCopy
	^ (self new setVersions: aCollection workingCopy: aWorkingCopy)
		signal! !

!Set methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:40'!
serializeWith: aMarshal
	aMarshal writeSet: self! !

!Set class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:15'!
materializeWith: aMarshal
	^ aMarshal readSetOfClass: self! !

SharedPool subclass: #MDBogusPoolB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

SharedPool subclass: #MDBogusPoolA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

Object subclass: #MDBogusA
	instanceVariableNames: 'one'
	classVariableNames: 'Alpha'
	poolDictionaries: 'MDBogusPoolA'
	category: 'Monticello2-Fakes'!

MDBogusA class
	instanceVariableNames: 'aleph'!

!Boolean class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:52'!
materializeWith: aMarshal
	^ aMarshal readBooleanOfClass: self! !

!Boolean methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:50'!
serializeWith: aMarshal
	aMarshal writeBoolean: self! !
MDMarshal initialize!
MDHashstamp initialize!
